
import scala.compat.Platform.currentTime
import scala.io.Source
import scala.reflect.ClassTag

val fname = "words.txt"

class GrowArray[T : ClassTag] {
  private var A = new Array[T](32)
  private var cursize = 0

  def capacity: Int = A.length
  def length: Int = cursize
  def apply(i: Int): T = A(i)
  def update(i: Int, s: T) = { A(i) = s }
  def += (s: T) = {
    if (length == capacity) {
      val B = A
      A = new Array[T](2 * B.length)
      for (i <- 0 until B.length)
	A(i) = B(i)
    }
    A(cursize) = s
    cursize += 1
  }
}

def readWords(): GrowArray[Int] = {
  val F = Source.fromFile(fname)
  var A = new GrowArray[Int]
  for (line <- F.getLines()) {
    A += line.length
  }
  A
}

println("Starting...")
val t0 = currentTime
val A = readWords()
val t1 = currentTime
printf("Reading all %d words took %d milliseconds\n", A.length, t1 - t0)
println
println("The first ten word lengths are:")
for (i <- 0 until 10)
  println(A(i))

